CREATE OR REPLACE PROCEDURE JEFY_MARCHES.MAJ_SA_CONTROLE_NACRES_2014 AS 
CURSOR C1
  IS SELECT SACM.*
    FROM JEFY_MARCHES.SA_CONTROLE_CODE_MARCHE SACM INNER JOIN JEFY_MARCHES.CODE_MARCHE CM ON SACM.CM_ORDRE = CM.CM_ORDRE;
  
  CURRENT_SACM JEFY_MARCHES.SA_CONTROLE_CODE_MARCHE%ROWTYPE;
  CM_ORDRE_NACRES INTEGER;
  CPT INTEGER;
  
BEGIN
  OPEN C1;
      LOOP
        FETCH C1 INTO CURRENT_SACM;
        EXIT WHEN C1%NOTFOUND;
        
        BEGIN
        -- VÉRIFICATION DE L'EXITENCE D'UNE CORRESPONDANCE NACRES
        SELECT CM2.CM_ORDRE INTO CM_ORDRE_NACRES
        FROM JEFY_MARCHES.CODE_MARCHE CM1, JEFY_MARCHES.CODE_MARCHE CM2, JEFY_MARCHES.CORRESPONDANCE_CN COCN
        WHERE CM1.CM_CODE = COCN.ANCIEN_CN AND COCN.CN_NACRES=CM2.CM_CODE AND CM1.CM_ORDRE=CURRENT_SACM.CM_ORDRE;
          
        SELECT COUNT(*) INTO CPT FROM JEFY_MARCHES.SA_CONTROLE_CODE_MARCHE WHERE CM_ORDRE=CM_ORDRE_NACRES AND SVAC_ID = CURRENT_SACM.SVAC_ID;
        
        -- VÉRIFICATION DE L'EXITENCE D'UNE ENTRÉE DANS JEFY_MARCHES.SA_CONTROLE_CODE_MARCHE POUR LE MÊME CM_ORDRE NACRES ET LE MÊME UTILISATEUR
        IF(CPT>0) THEN
            DBMS_OUTPUT.PUT_LINE ('UN CODE_MARCHE EXISTE DÉJÀ POUR CET UTILISATEUR (SVAC_ID : '||CURRENT_SACM.SVAC_ID||') ET CE CM_ORDRE  : '||CURRENT_SACM.CM_ORDRE||'');
        
        ELSE
            INSERT INTO JEFY_MARCHES.SA_CONTROLE_CODE_MARCHE (CCMA_DATE, CCMA_ID, CM_ORDRE, SVAC_ID)
            VALUES (CURRENT_SACM.CCMA_DATE, CURRENT_SACM.CCMA_ID, CM_ORDRE_NACRES, CURRENT_SACM.SVAC_ID) ;

        END IF;
        
        EXCEPTION
          WHEN NO_DATA_FOUND THEN
                DBMS_OUTPUT.PUT_LINE ('PAS DE CORRESPONDANCE NACRES,  CM_ORDRE : '||CM_ORDRE_NACRES||'');
        END;
    END LOOP;
  CLOSE C1;
END MAJ_SA_CONTROLE_NACRES_2014;